/*  
    I haven't coded for 20 years plus
    I am not familiar with Javascript -
    I am sorry for the messi code :)   
*/

// include the api
const { refObject, world, Color, Rotator, Vector } = require('@tabletop-playground/api');

// globals
actualPlayer = 1;   // green always makes the first move! works only WITHOUT VAR decl.!!
foundSalta = false; // works only WITHOUT VAR decl.!!
firstRun = true;
gameOver = false;


sendMessageToOponent = function (thisPlayer, message) {

    let allPlayers = world.getAllPlayers();
    
    if (allPlayers.length > 1)
    {  // if there are two players
        let otherPlayer = allPlayers[1];
        if (thisPlayer != allPlayers[0]) otherPlayer = allPlayers[0];   
        otherPlayer.showMessage(message);
    }
    else
    {  // if you are playing against yourself
        thisPlayer.showMessage(message);
    }
};


// add some functions to store and retrieve 
// the position of an object

var normPos = function (wobblyPos) {
        
    return new Vector(Math.round(wobblyPos[0]), Math.round(wobblyPos[1]), wobblyPos[2]); // keep z untouched, or otherwise piece levitates
};

var getIndex = function(obj) {
    var name = obj.getTemplateName();
    index = parseInt(name[0])+((name[1] === "p")*5+(name[1] === "s")*10)+((name[2] === "r")*15)-1;
    return(index);
};

var savePos = function(obj,xyz) {
//    console.log(obj.getTemplateName()+" prev. Pos: "+previousPos[getIndex(obj)][0]+"/"+previousPos[getIndex(obj)][1]);
    previousPos[getIndex(obj)] = normPos(xyz);
//    console.log(obj.getTemplateName()+" saved Pos: "+previousPos[getIndex(obj)][0]+"/"+previousPos[getIndex(obj)][1]+"\n---");
};

var getPos = function(obj) {
    return(previousPos[getIndex(obj)]);
};

savePos(refObject,refObject.getPosition());

var oldPos = getPos(refObject);
var blockPlayer = false;
var allObjects = world.getAllObjects();

greenHand = world.getObjectById("grw"); greenHand.setPosition(new Vector(-4,25,90));
redHand = world.getObjectById("wzo"); redHand.setPosition(new Vector(4,-25,90)); 

const testRun = false; // to be set manually
const hiColor = new Color(1, 1, 0, 1); // yellow is highlighting color
const loColor = new Color(1, 1, 1, 1); // white is the low color
const offColor = new Color(0,0,1,10); // blue is out of game color
// const piecesPerColor = 15; // 15 pieces per color
const gameOverText = "*** G A M E  O V E R ***";

// greenStatus = piecesPerColor; // number of green pieces at the start of the game
// redStatus = piecesPerColor;  // number of red pieces at the start of the game

// add a function to be called when
// this object gets grabbed by any player

refObject.onGrab.add(
    function (obj, player) {

        if (gameOver) {
            player.showMessage(gameOverText);
            blockPlayer = true; 
            return;
        }; 

        // test whether it is my turn

        let colorOfThisPiece = obj.getTemplateName()[2]; // actual players 'SteinFarbe'        

        if (testRun) console.log("Grabbed! TP slot:", player.getSlot()," Player ID:", actualPlayer);

        if ((world.getAllPlayers().length > 1) && (actualPlayer !=  (1 - 2*(player.getSlot() === 2)))) {

            if(firstRun) player.showMessage("Green Has First Move!"); else player.showMessage("Not Your Turn!");

            blockPlayer = true;
            
            return;
        };

        if (((actualPlayer ===  1) && (colorOfThisPiece === "r")) || 
            ((actualPlayer === -1) && (colorOfThisPiece === "g"))) {
 
            player.showMessage("Don't Move Your Oponent's Pieces!");

            blockPlayer = true;
                       
            return; 
        };

        // test if I there is s Salta requirement left over

        allObjects = world.getAllObjects();

        foundSalta = false;

        for (var i = 0; i < allObjects.length; i++) {  // we need to look a ALL pieces to find out

            var colorOfPiece = allObjects[i].getTemplateName()[2];
            var primeColor = allObjects[i].getPrimaryColor()[2];

            if ((colorOfPiece === colorOfThisPiece) && (primeColor === hiColor[2])) {// if the currently inspected piece is of the color of This piece
                                                                                     // and if it is marked for Salta, i.e. required to jump over
                foundSalta = true;
                break;
            };
        };

        let primeColorOfThis = obj.getPrimaryColor()[2]; // actual players 'SteinFarbe'        

        if ((foundSalta) && (primeColorOfThis !== hiColor[2])) { // if there is a requirement for salta but This piece is NOT marked for salta 
            player.showMessage("¡SALTA! One Piece Marked in Yellow Must Jump!");
            shuffleBack(obj);                   
            blockPlayer = true;
        };
    });



// add a function to be called when
// this object gets moved off the board

var shuffleBack = function (obj) {
    obj.setLinearVelocity(new Vector(0,0,0)); obj.setAngularVelocity(new Rotator(0,0,0));
    obj.setPosition(getPos(obj),0.6); obj.setRotation(new Rotator(0,0,0),0);
    if (testRun) console.log(obj.getTemplateName()+" shuffled back to "+getPos(obj));
};


refObject.onHit.add(
    function (obj) {
        if (obj.getPosition() != getPos(obj)) shuffleBack(obj);
    });


// add a function to be called to calculate
// the target position of a piece to finish the game

var tarCalc = function (obj) {
        
    var pieceName = obj.getTemplateName();
        
    var pieceEyes = parseInt(pieceName[0]); 
    var pieceType = pieceName[1];    
    var pieceColor = pieceName[2];
    var turnTable =  2 * (pieceColor == "g") - 1;

    var targetX = (10 * (pieceType == "s") + 14 * (pieceType == "m") + 18 * (pieceType == "p")) *turnTable;
    var targetY = (-22 + 8 * pieceEyes - 4 * (pieceType == "m")) * turnTable; 

    return {
        x: targetX,
        y: targetY,
    };
};

// add a function to be called when
// this object gets released by a player

refObject.onSnapped.add(
    function (obj, player) {
        
        if (blockPlayer) { // move back to previous location
            shuffleBack(obj);
            blockPlayer = false;
            return;
        }
   
        var LC = obj.localPositionToWorld();
        var xdist = Math.abs(LC[0] - getPos(obj)[0]);
        var ydist = Math.abs(LC[1] - getPos(obj)[1]);

        xdist = Math.round(xdist);
        ydist = Math.round(ydist);

        console.log("delta: ",xdist,ydist);

        if ((xdist == 0) && (ydist === 0)) {  // piece was just lifted

            if (testRun) 
            {
                let nowPos = normPos(LC);
                let endPos = new Vector(tarCalc(obj).x, tarCalc(obj).y,LC[2]);

                console.log("--------------");
                console.log(obj.getTemplateName() + " is @ x = " + nowPos[0] + "  y = " + nowPos[1] + " z = "+ nowPos[2]);
                console.log("Target is x = " + endPos[0] + "  y = " + endPos[1]);
                world.drawDebugLine(nowPos, endPos, new Color(0, 1, 1, 255), 2, 0.15);  // sending beam to target position
            };

            return; // no further testing needed
        }

        var oneStep = (xdist === ydist) && (xdist === 4); // was it moved only one field? 

        var objName = obj.getTemplateName();
        var colorOfPiece = objName[2]; // steinfarbe
        var frwrd = ((LC[0] > getPos(obj)[0]) === (colorOfPiece === "g")); // was the piece moved forward? 

        var from = LC.add(new Vector(0, 0, 0));
        var to = LC.add(new Vector(0, 0, -0.5)); // poking downwards
        var stacked = world.lineTrace(from, to).length < 3; // was the piece stacked on top another piece? (if board & table are not poked) 

        var scan = world.lineTrace(getPos(obj), LC);
        var theOponent = scan[0].object;
        var openentPos = theOponent.getPosition(); 
        var theOpenentsName = theOponent.getTemplateName();
        var isOponent = (scan.length > 1) && (theOpenentsName[2] != colorOfPiece); // is there an oponent ahead?
        var jumpedOver = frwrd && ((xdist === 8) && (ydist === 8)) && isOponent && foundSalta; // was the piece legally moved forward two fields?

        if (testRun) console.log("!stacked:" + (!stacked) + " && (oneStep && !foundSalta):" + (oneStep && !foundSalta) + " || jumpedOver:" + jumpedOver)

        if (!stacked && ((oneStep && !foundSalta) || jumpedOver)) // legal move!
        {
            firstRun = false; // the first move by green is done

            oldPos = getPos(obj); // remember the old position for the records
 
            savePos(obj,LC); // remember the new position as legal

            if (jumpedOver) {   
            
                console.log(obj.getTemplateName()+" jumped over "+ theOpenentsName+"!");
                
                // theOponent.setPosition(new Vector(0,0,85)); // 杀 put the piece to the hades :>
                theOponent.setPosition(new Vector(-10*Math.random(),30+10*Math.random(),85));
                theOponent.setPrimaryColor(offColor); // and mark it as 'out of game'

                if (theOpenentsName[2] == "g") greenStatus--; else redStatus--; // keep track of the number of pieces in the game
    
                var swapObjName = theOpenentsName.substr(0,2)+objName[2]+"$";
                var swapObj = world.getObjectById(swapObjName);
    
                // console.log(swapObj.getTemplateName(),swapObj.getPrimaryColor(),offColor);
    
                if (swapObj.getPrimaryColor()[1] == offColor[1]) {
                        
                    swapObj.setPrimaryColor(loColor); // get it back from the hades!    
                    swapObj.setPosition(openentPos);  // replace the oponents piece by your own kind :>
                    savePos(swapObj,openentPos);
    
                    if (objName[2] == "g") greenStatus++; else redStatus++; // add to the number of pieces in the game                
                };
            };
    
            gameOver = isGameOver(); // test on game over

            if (gameOver == false) { // it ain't over yet!

                 // search for a neighboring piece 
                if (findSaltaPieceAtPosition(obj)) sendMessageToOponent(player,"¡S_A_L_T_A!");

                actualPlayer = -1 * actualPlayer; // turn the table!
                
                if (testRun) console.log("Switched! TP Slot =",player.getSlot()," Player ID =",actualPlayer);

                // if (testRun)
                console.log("'" + obj.getTemplateName() + "' moved from " + oldPos[0] + "/" + oldPos[1] + " to " + getPos(obj)[0] + "/" + getPos(obj)[1]);

                if (actualPlayer > 0) {

                    greenHand.setPrimaryColor(new Color(0, 1, 0, 1)); 
                    redHand.setPrimaryColor(new Color(0, 0, 0, 0));} // renders it invisible

                else {

                    redHand.setPrimaryColor(new Color(1, 0, 0, 1)); 
                    greenHand.setPrimaryColor(new Color(0, 0, 0, 0));} // renders it invisible
            }
            else
            {
                sendMessageToOponent(player,gameOverText);

                redHand.setPrimaryColor(new Color(0, 0, 0, 0));   // renders it invisible
                greenHand.setPrimaryColor(new Color(0, 0, 0, 0)); // renders it invisible
            }
        }
        else 
        {
            player.showMessage("Unallowed Move!");
            shuffleBack(obj);
        };
    });


/*
 * determine whether the game is over
 */

var isGameOver = function () {

    var tada = false; // not over yet :)
    let goldColor = new Color(1,1,0.67,1); // gold color

    var greenComplete = 0; // no pieces in end position
    var redComplete = 0;
    var allRedPieces = new Array(redStatus); 
    var allGreenPieces = new Array(greenStatus); 

    for (var n = 0; n < allObjects.length; n++) { // loop over all pieces

        var nowObj = allObjects[n];

        if ((nowObj.getTemplateName()[3] == "$") && (nowObj.getPrimaryColor()[1] != offColor[1])) // only pieces shall pass that are still in the game
        {

            // console.log("!"+nowObj.getTemplateName());

            var nowPos = normPos(nowObj.localPositionToWorld());
            var aimPos = new Vector(tarCalc(nowObj).x,tarCalc(nowObj).y,nowPos[2]);

            nowObj.setRoughness(1); nowObj.setMetallic(0); // for now make it look "ordinary"

            if (testRun)
            {
                console.log("- " + nowObj.getTemplateName() + " color " + nowObjCol);
                console.log("nowPos = " + nowPos);
                console.log("aimPos = " + aimPos);
            };

            if ((nowPos[0] === aimPos[0]) && (nowPos[1] === aimPos[1])) {  // this piece is where it aimed at

                nowObj.setRoughness(0.27); nowObj.setMetallic(1); // make it a bit shiny

                var nowObjCol = nowObj.getTemplateName()[2];

                if (nowObjCol === "g") {allGreenPieces[greenComplete] = nowObj; greenComplete++;};
                if (greenComplete === greenStatus) { // all green pieces still in the game have reached their final position
                    for (var i = 0; i < greenStatus; i++) { // loop over all pieces of the winning color
                        allGreenPieces[i].setPrimaryColor(goldColor);
                    };
                    tada = true; // yeah!!!
                };

                if (nowObjCol === "r") {allRedPieces[redComplete] = nowObj; redComplete++;};
                if (redComplete === redStatus) { // all red pieces have reached their final position
                    for (var i = 0; i < redStatus; i++) { // loop over all pieces of the winning color
                        allRedPieces[i].setPrimaryColor(goldColor);
                    };
                    tada = true; // yeah!!!
                };
            };
        };
    };

    if (testRun) console.log("green " + greenComplete + " @home, red " + redComplete + " @home" + " tada = " + tada);

    return(tada);
};


/*
 * Look for salta pieces at the given position, 
 * determine the jump condition and return it if existing
 */

var findSaltaPieceAtPosition = function (actualPiece) {

   var salta = false;

    if (testRun) console.log("---");

    const spikeStart = 1.8; // the probe we stick out to find other pieces
    const spikeStop = 5;

    for (var n = 0; n < allObjects.length; n++) { // loop over all pieces

        var nowObject = allObjects[n];
        var nowObjectName = nowObject.getTemplateName();

        if (nowObjectName.includes("$")) { // only pieces shall pass

            let refColor = actualPiece.getTemplateName()[2]; // the color of the piece that just has been moved
            var nowColor = nowObjectName[2]; // the color is defined by the 3rd char in the piece model name

            if (nowColor === refColor) // investigate only objects of the color of the refObject  
            {
                if (nowObject.getPrimaryColor()[2] === hiColor[2]) nowObject.setPrimaryColor(loColor); // reset salta marking probably set before

//              var LC = nowObject.localPositionToWorld(); // didn't work
                var LC = nowObject.getPosition(); // remember the local position of the current piece

                var atEdge = (Math.abs(Math.round(LC[0])) == 18) || (Math.abs(Math.round(LC[1])) == 18); // are we at one of the edges of the board?

                // poking 45 degree to port
                var from = LC.add(new Vector(spikeStart * actualPlayer,  -spikeStart * actualPlayer, 0));
                var to = LC.add(new Vector(spikeStop * actualPlayer, -spikeStop * actualPlayer, 0));
                var matches = world.lineTrace(from, to); // the probe is sent 

                if (testRun) world.drawDebugLine(from, to, new Color(1, 0, 0, 255), 1, 0.1);

                if (matches.length > 0) // if any object was detected and it is an oponent 
                {
                    var prtObj = matches[0].object;  // there can only max one                
                    var prtColor = prtObj.getTemplateName()[2]; // 3rd char = color

                    if  (!atEdge && (prtColor != nowColor)) { // we are not at the edge of the board and it is an oponent

                        if (testRun) console.log(nowObject.getTemplateName(),"found",prtObj.getTemplateName(),"on port side");

                        // poking 135 degree behind
                        from = LC.add(new Vector(-spikeStart * actualPlayer,  spikeStart * actualPlayer, 0));
                        to = LC.add(new Vector(-spikeStop * actualPlayer, spikeStop * actualPlayer, 0)); 
                        var objBehind = world.lineTrace(from, to);

                        if (testRun) world.drawDebugLine(from, to, new Color(1, 0, 0, 255), 1, 0.1);

                        if (objBehind.length === 0) {
                        // There is an empty field behind!  
                            if (testRun) console.log(prtObj.getTemplateName(),"von ",nowObject.getTemplateName()," markiert");
                            prtObj.setPrimaryColor(hiColor); 
                            salta = true; 
                        };
                    };
                };

                // poking 45 degree to starboard
                from = LC.add(new Vector(spikeStart * actualPlayer,  spikeStart * actualPlayer, 0));
                to = LC.add(new Vector(spikeStop * actualPlayer, spikeStop * actualPlayer, 0));
                matches = world.lineTrace(from, to); // the probe is sent 
            
                if (testRun) world.drawDebugLine(from, to, new Color(0, 1, 0, 255), 1, 0.1);

                if (matches.length > 0)   // if any object was detected
                {               
                    var stbObj = matches[0].object;
                    var stbColor = stbObj.getTemplateName()[2];  // 3rd char = color

                    if  (!atEdge && (stbColor != nowColor)) { // we are not at the edge of the board and it is an oponent

                        if (testRun) console.log(nowObject.getTemplateName(),"found",stbObj.getTemplateName(),"on port side");

                        // poking 225 degree behind
                        from = LC.add(new Vector(-spikeStart * actualPlayer,  -spikeStart * actualPlayer, 0));
                        to = LC.add(new Vector(-spikeStop * actualPlayer, -spikeStop * actualPlayer, 0)); 
                        objBehind = world.lineTrace(from, to);

                        if (testRun) world.drawDebugLine(from, to, new Color(0, 1, 0, 255), 1, 0.1);

                        if (objBehind.length === 0) // There is an empty field behind!  
                        {
                            if (testRun) console.log(stbObj.getTemplateName(),"von ",nowObject.getTemplateName()," markiert");
                            stbObj.setPrimaryColor(hiColor); 
                            salta = true;
                        };
                    };
                };
            };
        };
    };

    return salta;
}
